let () =
  Graphics.open_graph " "

let size_x = Graphics.size_x ()
let size_y = Graphics.size_y ()

let image = Array.make_matrix size_y size_x Graphics.white

let color = ref 0

let random_color () = 
  (* Random.int Graphics.white *)
  !color 

let get_pixel x y =
  (Graphics.dump_image (Graphics.get_image x y 1 1)).(0).(0)

let get_pixel x y = 
  image.(x).(y)

let count_neighbours x y =
  let n = ref 0 in
    for i = -1 to 1 do
      for j = -1 to 1 do
        if i = 0 && j = 0 then ()
        else
          if get_pixel (x+i) (y+j) <> Graphics.white then
            incr n
      done
    done;
    !n

let step () =
  for i = 1 to size_y - 2 do
    for j = 1 to size_x - 2 do
      let neighbours = count_neighbours i j in
        match get_pixel i j with
          | 0XFF_FF_FF (*white:not alive*) ->
              if neighbours = 2 || neighbours = 3 then
                image.(i).(j) <- random_color()                 
              else
                ()
          | _ (*alive*) ->
              if neighbours = 2 then
                ()
              else
                image.(i).(j) <- Graphics.white
    done;
  done

let step () =
  let i, j = Random.int (size_y - 2) + 1, Random.int (size_x - 2) + 1 in
  let neighbours = count_neighbours i j in
    (*         Printf.printf "<%d,%d> %d\n%!" i j neighbours; *)
    match get_pixel i j with
      | 0XFF_FF_FF (*white:not alive*) ->
          if neighbours = 2 || neighbours = 3 then
            image.(i).(j) <- random_color()                 
          else
            ()
      | _ (*alive*) ->
          if neighbours = 2 then
            ()
          else
            image.(i).(j) <- Graphics.white

let _ = 
  Thread.create
    (fun () ->
      while true do
        (* color := Random.int Graphics.white; *)
        Graphics.draw_image (Graphics.make_image image) 0 0;
        (try Thread.delay 0.01 with _ -> ())
      done)
    ()

let () =
  Graphics.clear_graph ();
  Graphics.set_color (random_color());
  for i = 0 to size_y - 1 do
    for j = 0 to size_x - 1 do
      image.(i).(j) <- if Random.bool () then Graphics.white else Graphics.black
    done
  done;
  let f () =
    while true do
      step ();
      (* (try ignore(Unix.select [] [] [] 0.1) with _ -> ()) *)
    done
  in 
    List.iter
      Thread.join
      (List.map (fun f -> Thread.create f ()) [f; f; f; f; f;])
