(*
  to compile:
  ocamlopt -thread unix.cmxa -cclib -lunix -cclib -lpthread threads.cmxa -o pi pi.ml
*)


let line = ref 0

let line_m = Mutex.create ()
  
let pi n nb_th tab idx=
  let fl_n = float n 
  and cpt = ref 0 in
    while !line <= n do     
      (
	Mutex.lock line_m;
	incr line;
	let y = !line in
	  (
	    Mutex.unlock line_m; 
	    for x = 0 to n-1 do 
	      if (sqrt ((float x)**2. +. (float y)**2. )) <= fl_n then 
		incr cpt
	    done;
	  )
      )
    done;
    tab.(idx) <- !cpt

  
let _ = 
  try 
    (
      let n = int_of_string  Sys.argv.(1)
      and nb_th = int_of_string Sys.argv.(2)
      in
      let compteurs = Array.create nb_th (0)  in
      let threads = 
	Array.init
	  nb_th
	  (fun i -> (Thread.create (pi n nb_th compteurs) i ))
      in
	Array.iter Thread.join threads;
	for i = 1 to nb_th-1 do
	  compteurs.(0) <- compteurs.(0) + compteurs.(i);
	done;
	Printf.printf "Pi=%g\n"  (4. *. (float compteurs.(0)) /. ((float n)**2.))
    )
  with
      _ -> Printf.printf "use : %s  [radius : int] [nb threads : int]\n" Sys.argv.(0)
